#include "image.hpp"

Image::Image () {
	
}

Mat Image::getBlank () {
	if (blank.empty()) {
		blank = Mat::zeros(height, width, CV_8UC3);
	}
	return blank;
}

Mat Image::loadImage (string& image_path, uint64_t& x, uint64_t& y, uint64_t& w, uint64_t& h) {
  string located_path = samples::findFile(image_path);
  Mat loaded = imread(located_path, IMREAD_COLOR);
  Mat resized;
  Mat image = getBlank();

  if (loaded.empty()) {
      cerr << "Image " << loaded << " empty" << endl;
  } else {
      cout << "Loaded image " << image_path << endl;
      cout << "   dim " << loaded.cols << "x" << loaded.rows << endl;
      cout << "target " << w << "x" << h << endl;
      resize(loaded, resized, Size(h, w));
      //cout << " image " << image.cols << "x" << image.rows << endl;
      //cout << "resized " << resized.cols << "x" << resized.rows << endl;
      resized.copyTo(image(Rect(x, y, resized.cols, resized.rows)));
      flip(image, image, 0);

#if (CV_VERSION_MAJOR >= 4)
      cvtColor(image, image, cv::COLOR_BGR2RGB);
#else
      cvtColor(image, image, CV_BGR2RGB);
#endif
    }
    return image;
}